unit Databaze;

interface

uses ComCtrls, StdCtrls, MyTypes, Messages;

procedure UlozDatabazi;
function  VytvorNejakehoZaka:PZak;
procedure DealokujZaka(p:PZak);
procedure DealokujDisciplinu(p:PDisciplina);
function AddToListView(p:PZak;lv:TListView):TListItem;
procedure AddToComboBox(d:PDisciplina;cb:TComboBox;Enumering:Boolean);
procedure UpdateInListView(pwhat,pwith:PZak;lv:TListView);
procedure RemoveFromListView(p:PZak;lv:TListView);

implementation

uses Data, My_IO, MyUtils, SysUtils, Classes;

function AddToListView(p:PZak;lv:TListView):TListItem;
var ListItem:TListItem;
    s:string;
begin
  ListItem:=lv.Items.Add;
  ListItem.caption:=p^.prijmeni;
  ListItem.data:=p;
  ListItem.SubItems.add(p^.jmeno);
  if p^.typ_studia=8 then
    RocnikNaRimske(p^.aktualni_trida,s)
  else
    Str(p^.aktualni_trida,s);
  s:=s+'.'+p^.pismeno_tridy;
  ListItem.SubItems.add(s);
  p^.Flag2:=TRUE;
  AddToListView:=ListItem;
end;

procedure RemoveFromListView(p:PZak;lv:TListView);
var i:integer;
begin
  for i:=0 to lv.Items.Count-1 do
    with lv.Items.Item[i] do if Data=p then begin
      SubItems.Clear;
      Delete;
      break;
    end;
  p^.Flag2:=FALSE;
end;

procedure UpdateInListView(pwhat,pwith:PZak;lv:TListView);
var i:integer;
    s:string;
begin
  for i:=0 to lv.Items.Count-1 do
    with lv.Items.Item[i] do if Data=pwhat then begin
      SubItems.Clear;
      Caption:=pwith^.prijmeni;
      SubItems.add(pwith^.jmeno);
      if pwith^.typ_studia=8 then
        RocnikNaRimske(pwith^.aktualni_trida,s)
      else
        Str(pwith^.aktualni_trida,s);
      s:=s+'.'+pwith^.pismeno_tridy;
      SubItems.add(s);
      Data:=pwith;
      break;
    end;
end;

procedure AddToComboBox(d:PDisciplina;cb:TComboBox;enumering:Boolean);
var s:string;
begin
  if d=nil then exit;
  if Enumering then begin
    Str(d^.id,s);
    s:=d^.jmeno+'='+s;
  end else s:=d^.jmeno;
  cb.Items.Add(s);
end;

function  VytvorNejakehoZaka:PZak;
var p:PZak;
begin
  New(p);
  FillChar(p^,sizeof(TZak),0);
  p^.jmeno:=StrNew('Martin');
  p^.prijmeni:=StrNew('Mak');
  p^.bydliste:=StrNew('Lipov');
  p^.ulice:=StrNew('');
  p^.cislo_domu:=254;
  p^.datum_narozeni.d:=11;
  p^.datum_narozeni.m:=10;
  p^.datum_narozeni.r:=1982;
  p^.muz:=TRUE;
  p^.typ_studia:=8;
  p^.startovni_trida:=1;
  p^.posledni_trida:=8;
  p^.aktualni_trida:=8;
  p^.studuje:=TRUE;
  p^.pismeno_tridy:='A';
  p^.rocni_slozky:=TList.Create;
  p^.Flag0:=FALSE;
  VytvorNejakehoZaka:=p;
end;

procedure DealokujZaka(p:PZak);
var i,j:integer;
    pr:PRocniSlozka;
    pv:PVysledek;
begin
  if p <> nil then begin
    if p^.jmeno          <> nil then StrDispose(p^.jmeno);
    if p^.prijmeni       <> nil then StrDispose(p^.prijmeni);
    if p^.bydliste       <> nil then StrDispose(p^.bydliste);
    if p^.ulice          <> nil then StrDispose(p^.ulice);
    if p^.rocni_slozky   <> nil then begin
      for i:=0 to p^.rocni_slozky.Count-1 do begin
        pr:=p^.rocni_slozky.Items[i];
        if pr <> nil then begin
          if pr^.vysledky <> nil then begin
            for j:=0 to pr^.vysledky.Count-1 do begin
              pv:=pr^.vysledky.Items[j];
              if pv<>nil then Dispose(pv);
            end;
            pr^.vysledky.Free;
          end;
          Dispose(pr);
        end;
      end;
      p^.rocni_slozky.Free;
    end;
    Dispose(p);
  end;
end;

procedure DealokujDisciplinu(p:PDisciplina);
begin
  if p <> nil then begin
    if p^.jmeno <> nil then StrDispose(p^.jmeno);
    Dispose(p);
  end;
end;

procedure UlozDatabazi;
var f,f2: FILE;
begin
  if datainfo.otevrena then begin
    datainfo.TempName:='temp.ath';
    AssignFile(f,datainfo.TempName);
    Rewrite(f,1);Truncate(f);
    ZapisData(f, MDL, MZL);
    AssignFile(f2, datainfo.FileName);
    Reset(f2);CloseFile(f2); Erase(f2);
    CloseFile(f);
    Rename(f, datainfo.FileName);
    datainfo.ulozena:=TRUE;
    datainfo.TempName:='';
  end;
end;

end.
