unit MyTypes;

interface
uses Classes;

type TDatum = record
       d:Byte;
       m:Byte;
       r:Integer;
     end;
     TVysledek = record
       Disciplina:Byte; // id discipliny
       jednotek  :Real; // dosazeny pocet jednotek
     end;
     TRocniSlozka = record
       trida   :Byte;  // kdyby nahodou propadl, tak je stejna
       pocatek :TDatum;
       vysledky:TList; // vysledky u jednotlivych disciplin
     end;
     TZak = record
       jmeno          :PChar;
       prijmeni       :PChar;
       bydliste       :PChar;
       ulice          :PChar;
       cislo_domu     :Integer;
       datum_narozeni :TDatum;
       muz            :Boolean;
       zacatek_studia :TDatum; // kdy zacal na skole studovat
       typ_studia     :Byte;   // napr. kolikatilete gymnazium
       startovni_trida:Byte;   // kdyz na skolu prejde z jine skoly
       posledni_trida :Byte;   // kdyz ze skoly odejde driv
       aktualni_trida :Byte;   // aktualni trida (1..8 nebo 1..4)
       studuje        :Boolean;// jestli je jeste studentem skoly
       pismeno_tridy  :Char;   // A,B,C,...
       rocni_slozky   :TList;  // vysledky za kazdy rok studia
       Flag0          :Boolean;
       Flag1          :Boolean; // rezervovano pro potrebu filtru
       Flag2          :Boolean; // rezervovano pro potrebu filtru
       Flag3          :Boolean; // rezervovano pro potrebu filtru
     end;
     TDisciplina = record
       jmeno          :PChar;
       id             :Byte;
       format_jednotky:Byte; // sekundy/minuty/hodiny metry/kilometry
     end;
     DATABAZE_INFO = record
       otevrena:Boolean;
       ulozena :Boolean;
       FileName:string;
       TempName:string;
     end;
     TDistItem = record
       d1,d2: integer;
     end;
     TRokyItem = record
       rok1,rok2:integer; // rozmezi
     end;
     TTridyItem = record
       trida1,trida2:integer;
       typ_studia:integer;
       pismeno:Char;
     end;
     TFiltrItem = record
       Roky : TList;
       Tridy: TList;
     end;
     TFiltr = record
       stav_studia  :integer; // 0..2
       vlastni_vyber:integer; // 0..2
       pohlavi      :integer; // 0..2 (ignoruj/ch/d)
       uziti_filtru :integer; // 0..2
       podle_trid   :Boolean; // porovnavat podle trid
       podle_disc   :Boolean; // porovnavat podle disciplin
       ItemList     :TList;   // tridy a roky
       DisList:array[1..4] of TList;// discipliny
       // 1 splnene, 2 nesplnene, 3 jsou, 4 nejsou
     end;
     TSchema = record
       discipliny   :TList;  // seznam disciplin podle jejich id (v bytech)
     end;
     TRozmezi = record
       a,b:integer;
     end;
     THodnoty = array[0..255] of TRozmezi;
     TGenerator = class
      public
       jmena:TList;
       prijmeni:TList;
       mesta:TList;
       NGM,NGZ,VGM,VGZ:THodnoty;
       constructor Create;
       destructor  Free;
       procedure Clear;
       procedure NactiSeznam(path:string;var list:TList);
       procedure NactiHodnoty(path:string);
       procedure gJmeno(var s:string);
       procedure gPrijmeni(var s:string);
       procedure gMesto(var s:string);
       procedure gCislo(var i:integer);
       procedure gHodnotu(id:byte;NV:Boolean;MZ:Boolean;var h:Real);
       procedure FreeList(var list:TList);
     end;
     PZak = ^TZak;
     TCmpFun = function(pz1,pz2:PZak):integer;
     PVysledek = ^TVysledek;
     PRocniSlozka = ^TRocniSlozka;
     PDisciplina = ^TDisciplina;
     PFiltr      = ^TFiltr;
     PFiltrItem  = ^TFiltrItem;
     PTridyItem  = ^TTridyItem;
     PRokyItem   = ^TRokyItem;
     PDistItem   = ^TDistItem;
     PSchema     = ^TSchema;
     PCmpFun     = ^TcmpFun;
implementation
uses SysUtils, MyUtils;
constructor TGenerator.Create;
var i:integer;
begin
  jmena:=TList.Create;
  prijmeni:=TList.Create;
  mesta:=TList.Create;
  for i:=0 to 255 do begin
    NGM[i].a:=0;NGM[i].b:=0;
    NGZ[i].a:=0;NGZ[i].b:=0;
    VGM[i].a:=0;VGM[i].b:=0;
    VGZ[i].a:=0;VGZ[i].b:=0;
  end;
end;
destructor TGenerator.Free;
begin
  Clear;
end;
procedure TGenerator.Clear;
var i:integer;
begin
  FreeList(jmena);
  FreeList(prijmeni);
  FreeList(mesta);
  for i:=0 to 255 do begin
    NGM[i].a:=0;NGM[i].b:=0;
    NGZ[i].a:=0;NGZ[i].b:=0;
    VGM[i].a:=0;VGM[i].b:=0;
    VGZ[i].a:=0;VGZ[i].b:=0;
  end;
end;
procedure TGenerator.FreeList(var list:TList);
var i:integer;
begin
  if list<>nil then begin
    for i:=0 to list.Count-1 do
      Dispose(list.Items[i]);
    list.Clear;
    list.Free;
    list:=nil;
  end;
end;

procedure TGenerator.NactiSeznam(path:string;var list:TList);
var f:TextFile;
    ps:^string;
    j:integer;
begin
  if not FileExists(path) then exit;
  AssignFile(f, path);
  {$I-}
  Reset(f);
  if IOResult<>0 then exit;
  {$I+}
  if list=nil then list:=TList.Create;
  j:=0;
  while not Eof(f) do begin
    new(ps);
    readln(f, ps^);
    list.Add(ps);
    inc(j);
  end;
  CloseFile(f);
  if j<1 then MyMessageBox('Ze souboru nebyly nateny dn data','Info',0);
end;

procedure TGenerator.NactiHodnoty(path:string);
var f:TextFile;
    i,j,k,c:integer;
    s,buff:string;
    var a:array[0..9] of integer;
    skip:boolean;
begin
  if not FileExists(path) then exit;
  AssignFile(f, path);
  {$I-}
  Reset(f);
  if IOResult<>0 then exit;
  {$I+}
  j:=0;
  for i:=0 to 255 do begin
    NGM[i].a:=0;NGM[i].b:=0;
    NGZ[i].a:=0;NGZ[i].b:=0;
    VGM[i].a:=0;VGM[i].b:=0;
    VGZ[i].a:=0;VGZ[i].b:=0;
  end;
  while not Eof(f) do begin
    readln(f, s);
    buff:='';k:=0;
    skip:=FALSE;
    for i:=1 to length(s) do begin
      if not skip then begin
        if s[i] in ['[','(','{'] then
          skip:=TRUE;
      end else begin
        if not (s[i] in [']',')','}']) then
          continue;
        skip:=FALSE;
        continue;
      end;
      if s[i] in ['0'..'9'] then
        buff:=buff+s[i]
      else if buff<>'' then begin
        if k>8 then break;
        val(buff, a[k], c);
        inc(k);buff:='';
      end;
    end;
    if (buff<>'')and(k<9) then begin
      val(buff, a[k], c);
      inc(k);buff:='';
    end;
    if k<3 then continue;
    c:=a[0];
    if (c<0)or(c>255) then continue;
    if k>2 then begin NGM[c].a:=a[1];NGM[c].b:=a[2]; end;
    if k>4 then begin NGZ[c].a:=a[3];NGZ[c].b:=a[4]; end;
    if k>6 then begin VGM[c].a:=a[5];VGM[c].b:=a[6]; end;
    if k>8 then begin VGZ[c].a:=a[7];VGZ[c].b:=a[8]; end;
    {
    s:='';
    str(a[0],buff);s:=s+' '+buff;
    str(a[1],buff);s:=s+' '+buff;
    str(a[2],buff);s:=s+' '+buff;
    str(a[3],buff);s:=s+' '+buff;
    str(a[4],buff);s:=s+' '+buff;
    str(a[5],buff);s:=s+' '+buff;
    str(a[6],buff);s:=s+' '+buff;
    str(a[7],buff);s:=s+' '+buff;
    str(a[8],buff);s:=s+' '+buff;
    MyMessageBox(s,'ahoj',0);
    }
    inc(j);
  end;
  CloseFile(f);
  if j<1 then MyMessageBox('Ze souboru nebyly nateny dn data','Info',0);
end;

procedure TGenerator.gJmeno(var s:string);
var r:integer;
    ps:^string;
begin
  s:='';
  if jmena=nil then exit;
  with jmena do begin
    if Count<1 then exit;
    r:=random(Count);
    ps:=Items[r];
  end;
  if ps=nil then exit;
  s:=ps^;
  Dispose(jmena.Items[r]);
  jmena.Delete(r);
end;
procedure TGenerator.gPrijmeni(var s:string);
var r:integer;
    ps:^string;
begin
  s:='';
  if prijmeni=nil then exit;
  with prijmeni do begin
    if Count<1 then exit;
    r:=random(Count);
    ps:=Items[r];
  end;
  if ps=nil then exit;
  s:=ps^;
  Dispose(prijmeni.Items[r]);
  prijmeni.Delete(r);
end;
procedure TGenerator.gMesto(var s:string);
var r:integer;
    ps:^string;
begin
  s:='';
  if mesta=nil then exit;
  with mesta do begin
    if Count<1 then exit;
    r:=random(Count);
    ps:=Items[r];
  end;
  if ps=nil then exit;
  s:=ps^;
end;
procedure TGenerator.gCislo(var i:integer);
begin
  i:=random(1000);
end;

procedure TGenerator.gHodnotu(id:byte;NV:Boolean;MZ:Boolean;var h:Real);
var tr:TRozmezi;
begin
  if NV then begin
    if MZ then tr:=NGM[id] // nizsi gymnazium, muzi
    else       tr:=NGZ[id];// nizsi gymnazium, zeny
  end else begin
    if MZ then tr:=VGM[id] // vyssi gymnazium, muzi
    else       tr:=VGZ[id];// vyssi gymnazium, zeny
  end;
  if (tr.a>tr.b)or(tr.b<0) then begin
    h:=0.0;
    exit;
  end;
  h:=tr.a+random(tr.b-tr.a+1)+random(100)/100.0;
  if h<1 then h:=0;
end;

begin
  randomize;
end.
