unit MyUtils;

interface
uses MyTypes, Classes, ComCtrls,StdCtrls;

function  MyMessageBox(const Text, Caption: string; Flags: Longint): Integer;
procedure RocnikNaRimske(trida:integer;var s:string);
function  RimskeNaRocnik(s:string):integer;
function  VytvorFiltr(s,sd:string):PFiltr;
procedure DealokujFiltr(var f:PFiltr);
procedure FiltrToString(f:PFiltr;var s:string);
function  VyhovujeFiltru(z:PZak;f:PFiltr):Boolean;
function  VyhovujeHledani(pz:PZak):Boolean;
procedure CreateRS(rss:Tlist;var rsd:TList); // rss - zdroj, rds-kopie
procedure GenerujRS(pz:PZak;var rsList:TList);
procedure ClearLV(var lv:TListView);
procedure DisposeRS(t:TList);
procedure GetDisciplineName(id:byte; var s:string);
function  GetDisciplineId(s:string):integer;
function  GetDiscipline(id:byte):PDisciplina;
function  IsFreeID(DisList:TList; cmpId:integer):boolean;
function  GenerujID(DisList:TList):integer;
procedure RefreshDisLV(DisList:TList;lv:TListView);
procedure RefreshDisCB(DisList:TList;cb:TComboBox;enumerate:Boolean);
procedure RefreshSchLV(Sch:PSchema;lv:TListView);
procedure J2F(j:Real;var s:string);
procedure F2J(s:string;var r:Real;id:byte);
procedure DealokujSchema(s:PSchema);
procedure UpdateSch(Sch:PSchema);
procedure ZobrazDisLVBezSch(DisList:TList;lv:TListView;Sch:PSchema);
procedure PouzijSchema(Sch:PSchema;rs:PRocniSlozka);
function  CompareStrings(const s1, s2:string):integer;
function  CompareFunction(pz1, pz2:PZak):integer;
function cmp1(var pz1,pz2:PZak):integer;
function cmp2(var pz1,pz2:PZak):integer;
function cmp3(var pz1,pz2:PZak):integer;
function cmp4(var pz1,pz2:PZak):integer;
function cmp5(var pz1,pz2:PZak):integer;
function cmp6(var pz1,pz2:PZak):integer;
function cmp7(var pz1,pz2:PZak):integer;
function cmp8(var pz1,pz2:PZak):integer;
function cmp9(var pz1,pz2:PZak):integer;
function StrConv(src:string):PChar;

implementation
uses SysUtils, Forms, Data, Main;

// j - udava pocet jednotek, s - vstup cislo discipliny, vystup - formatovany retezec
procedure J2F(j:Real;var s:string);
var id,i:integer;
    dkm,dm,dcm,ch,cm,cs,css:integer;
    c:integer;
    a:longint;
    pd:PDisciplina;
    sp1:string[20];
    jp1:Real;
begin
  c:=0;
  val(s,id,i);
  str(j:0:2,s);
  if i<>0 then exit;
  if MDL=nil then exit;
  for i:=0 to MDL.Count-1 do begin
    pd:=MDL.Items[i];
    if pd^.id=id then begin
      c:=pd^.format_jednotky;
      break;
    end;
  end;
  case c of
    0:exit;
    1:begin
      jp1:=j*1000;     // prevest na milimetry
      a:=Trunc(jp1);   // 'a' je vzdalenost v milimetrech
      //dmm:=a mod   10; // zbyva milimetru
      a  :=a div   10; // prevod na cm
      dcm:=a mod  100; // zbyva metru
      a  :=a div  100; // prevod na metry
      dm :=a mod 1000; // zbyva metru
      dkm:=a div 1000; // zbyva kilometru
      str(dkm,sp1);s:=sp1+':';
      str(dm, sp1);s:=s+sp1+':';
      str(dcm,sp1);s:=s+sp1;
    end;
    2:begin
      jp1:=j*100;      // prevest na setiny sekundy
      a:=Trunc(jp1);   // 'a' je cas v setinach
      css:=a mod  100; // zbyva setin
      a  :=a div  100; // prevod na sekundy
      cs :=a mod   60; // zbyva sekund
      a  :=a div   60; // prevod na minuty
      cm :=a mod   60; // zbyva minut
      ch :=a div   60; // zbyva hodin
      str(ch, sp1);s:=sp1+':';
      str(cm, sp1);s:=s+sp1+':';
      str(cs, sp1);s:=s+sp1+':';
      str(css,sp1);s:=s+sp1;
    end;
  end;
end;

// s:vstupni formatovany retezec, j - vystupni pocet jednotek, id - cislo discipliny
procedure F2J(s:string;var r:Real;id:byte);
var i,j,x,k,max:integer;
    c:char;
    d:integer;
    tmpa:array[1..5] of integer;
    tmp:longint;
    s2:string[20];
    pd:PDisciplina;
begin
  val(s,r,x);
  d:=0;
  for i:=1 to 5 do tmpa[i]:=0;
  if MDL=nil then exit;
  for i:=0 to MDL.Count-1 do begin
    pd:=MDL.Items[i];
    if pd^.id=id then begin
      d:=pd^.format_jednotky;
      break;
    end;
  end;
  max:=length(s);
  k:=1;
  s2:='';
  for i:=max downto 1 do begin
    c:=s[i];
    if (c>='0')and(c<='9')then
      s2:=s2+c
    else begin
      if s2='' then continue;
      for j:=1 to (length(s2) div 2) do begin
        x:=length(s2)-j+1;
        c:=s2[j];s2[j]:=s2[x];s2[x]:=c;
      end;
      val(s2, tmp, x);
      if k>=5 then break;
      tmpa[k]:=tmp;inc(k);
      s2:='';
    end;
  end;
  if s2<>'' then begin
    for j:=1 to (length(s2) div 2) do begin
      x:=length(s2)-j+1;
      c:=s2[j];s2[j]:=s2[x];s2[x]:=c;
    end;
    val(s2, tmp, x);
    if k<5 then begin
      tmpa[k]:=tmp;
      s2:='';
    end;
  end;
  case d of
    0:exit;
    1:begin
      tmp:=tmpa[3]*100000+tmpa[2]*100+tmpa[1];
      r:=tmp;
      r:=r/100;
    end;
    2:begin
      tmp:=tmpa[4]*360000+tmpa[3]*6000+tmpa[2]*100+tmpa[1];
      r:=tmp;
      r:=r/100;
    end;
  end;
end;

procedure RefreshDisCB(DisList:TList;cb:TComboBox;enumerate:Boolean);
var i:integer;
    pd:PDisciplina;
    s:string;
begin
  cb.Clear;
  if DisList=nil then exit;
  if enumerate then
    for i:=0 to DisList.Count-1 do begin
      pd:=DisList.Items[i];
      if pd<>nil then begin
        if pd^.jmeno=nil then s:=''
        else begin
          str(pd^.id, s);
          s:=pd^.jmeno+'='+s;
        end;
        cb.Items.Add(s);
      end;
    end
  else
    for i:=0 to DisList.Count-1 do begin
      pd:=DisList.Items[i];
      if pd<>nil then begin
        if pd^.jmeno=nil then s:=''
        else s:=pd^.jmeno;
        cb.Items.Add(s);
      end;
    end;
end;

procedure RefreshDisLV(DisList:TList;lv:TListView);
var i:integer;
    pd:PDisciplina;
    ListItem:TListItem;
    s:string;
begin
  if lv<>nil then ClearLV(lv);
  if DisList=nil then exit;
  for i:=0 to DisList.Count-1 do begin
    pd:=DisList.Items[i];
    if pd<>nil then begin
      ListItem:=lv.Items.Add;
      ListItem.Data:=pd;
      str(pd^.id, s);
      ListItem.Caption:=s;
      ListItem.SubItems.Add(pd^.jmeno);
      case pd^.format_jednotky of
        0:ListItem.SubItems.Add('');
        1:ListItem.SubItems.Add('m');
        2:ListItem.SubItems.Add('s');
      end;
    end;
  end;
end;

procedure ZobrazDisLVBezSch(DisList:TList;lv:TListView;Sch:PSchema);
var i:integer;
    pb:^byte;
    pd:PDisciplina;
    ListItem:TListItem;
    s:string;
    a:array[0..255]of Boolean; // je/neni ve schematu
begin
  if lv<>nil then ClearLV(lv);
  if DisList=nil then exit;
  for i:=0 to 255 do a[i]:=FALSE;
  if Sch<>nil then if Sch^.discipliny<>nil then
    for i:=0 to Sch^.discipliny.Count-1 do begin
      pb:=Sch^.discipliny.Items[i];
      a[pb^]:=TRUE;
    end;
  for i:=0 to DisList.Count-1 do begin
    pd:=DisList.Items[i];
    if pd<>nil then begin
      if a[pd^.id] then continue;
      ListItem:=lv.Items.Add;
      ListItem.Data:=pd;
      str(pd^.id, s);
      ListItem.Caption:=s;
      ListItem.SubItems.Add(pd^.jmeno);
      case pd^.format_jednotky of
        0:ListItem.SubItems.Add('');
        1:ListItem.SubItems.Add('m');
        2:ListItem.SubItems.Add('s');
      end;
    end;
  end;
end;

procedure RefreshSchLV(Sch:PSchema;lv:TListView);
var i:integer;
    ListItem:TListItem;
    s:string;
    pb:^byte;
    pd:PDisciplina;
begin
  if lv<>nil then ClearLV(lv);
  if Sch=nil then exit;
  if Sch^.discipliny=nil then exit;
  for i:=0 to Sch^.discipliny.Count-1 do begin
    pb:=Sch^.discipliny.Items[i];
    if pb=nil then continue; // musi exist. cislo discipliny
    ListItem:=lv.Items.Add;
    ListItem.Data:=pb;
    Str(pb^, s);
    ListItem.Caption:=s;

    pd:=GetDiscipline(pb^);
    if pd=nil then continue; // pod cislem musi byt disciplina

    GetDisciplineName(pb^, s);
    ListItem.SubItems.Add(s);
    case pd^.format_jednotky of
      0:ListItem.SubItems.Add('');
      1:ListItem.SubItems.Add('m');
      2:ListItem.SubItems.Add('s');
    end;
  end;
end;

// ze seznamu disciplin schematu vyradi ty, ktere nejsou v MDL
procedure UpdateSch(Sch:PSchema);
var i:integer;
    a:array[0..255] of Boolean;
    pd:PDisciplina;
    pb:^byte;
begin
  if Sch=nil then exit;
  if MDL=nil then begin
    DealokujSchema(Sch);
    new(Sch);Sch^.discipliny:=TList.Create;
    exit;
  end;
  for i:=0 to 255 do a[i]:=FALSE;
  for i:=0 to MDL.Count-1 do begin
    pd:=MDL.Items[i];
    if pd=nil then continue;
    if pd^.id in [0..255] then begin
      a[pd^.id]:=TRUE;
    end;
  end;
  for i:=Sch^.discipliny.Count-1 downto 0 do begin
    pb:=Sch^.discipliny.Items[i];
    if pb^ in [0..255] then
      if a[pb^] then continue; // disciplina je OK
    dispose(pb);
    Sch^.discipliny.Items[i]:=nil;
    Sch^.discipliny.Delete(i);
  end;
end;

procedure PouzijSchema(Sch:PSchema;rs:PRocniSlozka);
var i:integer;
    a:array[0..255] of Boolean;
    pv:PVysledek;
    pb:^byte;
begin
  if (Sch=nil)or(rs=nil) then exit;
  if Sch^.discipliny=nil then exit;
  if Sch^.discipliny.Count<1 then exit;
  if rs^.vysledky=nil then rs^.vysledky:=TList.Create;
  for i:=0 to 255 do a[i]:=FALSE;
  for i:=0 to rs^.vysledky.Count-1 do begin
    pv:=rs^.vysledky.Items[i];
    a[pv^.Disciplina]:=TRUE;
  end;
  for i:=0 to Sch^.discipliny.Count-1 do begin
    pb:=Sch^.discipliny.Items[i];
    if not a[pb^] then begin
      new(pv);
      pv^.Disciplina:=pb^;
      pv^.jednotek:=0.0;
      rs^.vysledky.Add(pv);
    end;
  end;
end;

function IsFreeID(DisList:TList; cmpId:integer):boolean;
var i :integer;
    pd:PDisciplina;
begin
  if DisList=nil then begin
    IsFreeId:=FALSE;
    exit;
  end;
  for i:=0 to DisList.Count-1 do begin
    pd:=DisList.Items[i];
    if pd<>nil then
      if cmpId=pd^.id then begin
        IsFreeId:=FALSE;
        exit;
      end;
  end;
  IsFreeId:=TRUE;
end;

function GenerujID(DisList:Tlist):integer;
var i:integer;
    pd:PDisciplina;
    tmp:array[0..255] of byte;
begin
  if DisList=nil then begin
    GenerujID:=-1;
    exit;
  end;
  FillChar(tmp[0], 256, 0);
  for i:=0 to DisList.Count-1 do begin
    pd:=DisList.Items[i];
    if pd<>nil then begin
      if pd^.id in [0..255] then
        tmp[pd^.id]:=1
    end;
  end;
  for i:=0 to 255 do
    if tmp[i]=0 then begin
      GenerujID:=i;
      exit;
    end;
  GenerujID:=-1;
end;

procedure GetDisciplineName(id:byte; var s:string);
var i:integer;
    pd:PDisciplina;
begin
  if MDL<>nil then begin
    for i:=0 to MDL.Count-1 do begin
      pd:=MDL.Items[i];
      if pd<>nil then if pd^.id=id then begin
        s:=pd^.jmeno;
        exit;
      end;
    end;
  end;
  s:='';
end;

function  GetDisciplineId(s:string):integer;
var i:integer;
    pd:PDisciplina;
begin
  if MDL<>nil then begin
    for i:=0 to MDL.Count-1 do begin
      pd:=MDL.Items[i];
      if pd<>nil then if pd^.jmeno=s then begin
        GetDisciplineId:=pd^.id;
        exit;
      end;
    end;
  end;
  GetDisciplineID:=-1;
end;

function  GetDiscipline(id:byte):PDisciplina;
var i:integer;
    pd:PDisciplina;
begin
  if MDL<>nil then begin
    for i:=0 to MDL.Count-1 do begin
      pd:=MDL.Items[i];
      if pd<>nil then if pd^.id=id then begin
        GetDiscipline:=pd;
        exit;
      end;
    end;
  end;
  GetDiscipline:=nil;
end;

procedure DisposeRS(t:TList);
var i,j:integer;
    prs:PRocniSlozka;
    pv:PVysledek;
begin
  if t<>nil then begin
    for i:=0 to t.Count-1 do begin
      prs:=t.Items[i];
      if prs <> nil then begin
        if prs^.vysledky<>nil then begin
          for j:=0 to prs^.vysledky.Count-1 do begin
            pv:=prs^.vysledky.Items[j];
            Dispose(pv);
          end;
          prs^.vysledky.Free;
        end;
        Dispose(prs);
      end;
    end;
    t.Free;
  end;
end;

procedure CreateRS(rss:TList;var rsd:TList);
var i,j:integer;
    prss,prsd:PRocniSlozka;
    pvs,pvd:PVysledek;
begin
  rsd:=TList.Create;
  if rss = nil then exit;
  for i:=0 to rss.Count-1 do begin
    prss:=rss.Items[i];
    New(prsd);
    prsd^.trida:=prss^.trida;
    prsd^.pocatek:=prss^.pocatek;
    prsd^.vysledky:=TList.Create;
    if prss^.vysledky<>nil then
      for j:=0 to prss^.vysledky.Count-1 do begin
        pvs:=prss^.vysledky.Items[j];
        New(pvd);
        pvd^:=pvs^;
        prsd^.vysledky.Add(pvd);
      end;
    rsd.Add(prsd);
  end;
end;

procedure GenerujRS(pz:PZak;var rsList:TList);
var i:integer;
    rs:PRocniSlozka;
begin
  if pz=nil then exit;
  if pz^.zacatek_studia.r<=1900 then exit;
  for i:=1 to pz^.aktualni_trida do begin
    new(rs);
    rs^.trida:=i;
    rs^.vysledky:=Tlist.Create;
    rs^.pocatek.d:=1;
    rs^.pocatek.m:=9;
    rs^.pocatek.r:=pz^.zacatek_studia.r+i-1;
    rsList.Add(rs);
  end;
end;

procedure ClearLV(var lv:TListView);
var t:TSortType;
    i:integer;
begin
  t:=lv.SortType;
  lv.SortType:=stNone;
  for i:=0 to lv.Items.Count-1 do begin
    lv.Items.Item[i].SubItems.Clear;
    lv.Items.Item[i].Data:=nil;
  end;
  lv.Items.Clear;
  lv.SortType:=t;
end;

function MyMessageBox(const Text, Caption: string; Flags: Longint): Integer;
var pc1,pc2:PChar;
begin
  pc1:=StrAlloc(Length(Text)+1);
  pc2:=StrAlloc(Length(Caption)+1);
  StrPCopy(pc1,Text);
  StrPCopy(pc2,Caption);
  MyMessageBox:=Application.MessageBox(pc1,pc2,Flags);
  StrDispose(pc1);
  StrDispose(pc2);
end;

procedure RocnikNaRimske(trida:integer;var s:string);
begin
  case trida of
    1:s:='I';
    2:s:='II';
    3:s:='III';
    4:s:='IV';
    5:s:='V';
    6:s:='VI';
    7:s:='VII';
    8:s:='VIII';
  else
    s:='';
  end;
end;

function  RimskeNaRocnik(s:string):integer;
var i:integer;
begin
  if s='I'   then i:=1 else
  if s='II'  then i:=2 else
  if s='III' then i:=3 else
  if s='IV'  then i:=4 else
  if s='V'   then i:=5 else
  if s='VI'  then i:=6 else
  if s='VII' then i:=7 else
  if s='VIII'then i:=8 else i:=0;
  RimskeNaRocnik:=i;
end;

function VyhovujeFiltru(z:PZak;f:PFiltr):Boolean;
type Tdpole=array [0..255] of byte;
const max = 50;
      maxta = 20;
var i,j,k,m,n,o:integer;
    fi:PFiltrItem;
    ri:PRokyItem;
    ti:PTridyItem;
    di:PDistItem;
    rs:PRocniSlozka;
    DelList:TList;
    ZrusRS:Boolean;
    vyhovuje,vyhovuje2:Boolean;
    dpole:Tdpole;
    zasobnik:array [0..max] of PRocniSlozka;
    zn:integer;
    tempa:array[0..maxta] of Boolean;
label ne, tridy_ok,jen_podle_disciplin;

procedure dpoleFill(rs:PRocniSlozka;var p:Tdpole;add:Boolean);
var i:integer;
    pv:PVysledek;
begin
  if not add then for i:=0 to 255 do p[i]:=0;
  if rs=nil then exit;
  if rs^.vysledky=nil then exit;
  if rs^.vysledky.Count=0 then exit;
  for i:=0 to rs^.vysledky.Count-1 do begin
    pv:=rs^.vysledky.Items[i];
    if pv=nil then continue;
    if not (pv^.Disciplina in [0..255]) then continue;
    if (add)and(p[pv^.Disciplina]<>0) then begin
      if pv^.jednotek > 0.0 then p[pv^.Disciplina]:=3;
    end else begin
      p[pv^.Disciplina]:=1;
      if pv^.jednotek > 0.0 then p[pv^.Disciplina]:=3;
    end;
  end;
end;
function dTest(di:PDistItem;cmp_bits,cmp_val:byte;var p:Tdpole):Boolean;
var i:integer;
begin
  for i:=byte(di^.d1) to byte(di^.d2) do
    if (p[i] and cmp_bits)<>cmp_val then begin
      dTest:=FALSE;
      exit;
    end;
  dTest:=TRUE;
end;

begin
  zasobnik[0]:=nil;
  DelList:=TList.Create;// seznam RS, ktere nakonec smazeme
  zrusRS:=FALSE;        // predpoklad, ze seznam RS existuje
  case f^.stav_studia of
    1: if not z^.studuje then goto ne; // studuje
    2: if z^.studuje then goto ne;     // nestuduje
  end;
  case f^.vlastni_vyber of
    1: if not z^.Flag1 then goto ne;   // oznacene
    2: if z^.Flag1 then goto ne;       // neoznacene
  end;
  case f^.pohlavi of
    1: if not z^.muz then goto ne;     // chlapec
    2: if z^.muz then goto ne;         // divka
  end;
  case f^.uziti_filtru of
    1: if z^.Flag2 then goto ne;       // zbytek databaze
    2: if not z^.Flag2 then goto ne;   // stavajici filtr
  end;
  // pokud neexistuje seznam RS
  if z^.rocni_slozky=nil then begin
    zrusRS:=TRUE;
    z^.rocni_slozky:=TList.Create;
  end;
  for i:=0 to maxta do tempa[i]:=FALSE;
  for i:=0 to z^.rocni_slozky.Count-1 do begin
    rs:=z^.rocni_slozky.Items[i];
    if rs=nil then continue;
    if rs^.trida<=maxta then tempa[rs^.trida]:=TRUE;
  end;
  for i:=1 to z^.typ_studia do
    if tempa[i]=FALSE then begin
      new(rs);
      rs^.trida:=i;
      rs^.pocatek.d:=1;
      rs^.pocatek.m:=9;
      rs^.pocatek.r:=z^.zacatek_studia.r+i-1;
      rs^.vysledky:=TList.Create;
      z^.rocni_slozky.Add(rs);
      DelList.Add(rs);
    end;
  // ted by mely byt dotvoreny vsechny RS, takze muzeme
  // porovnavat podle nich

  zn:=0;vyhovuje:=FALSE;// predpokladame, ze nevyhovuje
  if f^.podle_trid then begin
    // iterace pro rocni slozky
    for i:=0 to z^.rocni_slozky.Count-1 do begin
      rs:=z^.rocni_slozky.Items[i];
      if rs=nil then continue;
      if z^.studuje then begin
        if (rs^.trida<z^.startovni_trida)or(rs^.trida>z^.aktualni_trida) then
          continue;
      end else
        if (rs^.trida<z^.startovni_trida)or(rs^.trida>z^.posledni_trida) then
          continue;
      // iterace pro prvky filtru
      for j:=0 to f^.ItemList.Count-1 do begin
        fi:=f^.ItemList.Items[j];
        if fi=nil then continue;
        if (fi^.Roky=nil)or(fi^.Tridy=nil) then continue;
        for k:=0 to fi^.Roky.Count-1 do begin
          ri:=fi^.Roky.Items[k];
          if ri=nil then continue;
          if (ri^.rok1>rs^.pocatek.r)or(rs^.pocatek.r>ri^.rok2) then continue;
          for m:=0 to fi^.Tridy.Count-1 do begin
            ti:=fi^.Tridy.Items[m];
            if ti=nil then continue;
            if (z^.typ_studia<>ti^.typ_studia)or(z^.pismeno_tridy<>ti^.pismeno)or
               (rs^.trida>ti^.trida2)or(rs^.trida<ti^.trida1)then continue;
            // nalezena vyhovujici polozka
            vyhovuje:=TRUE;
            break;
          end;
          if vyhovuje then break;
        end;
        if vyhovuje then break;
      end;
      if not vyhovuje then continue;
      if not f^.podle_disc then goto tridy_ok;
      zasobnik[zn]:=rs;inc(zn); if zn>=max then goto ne;
      vyhovuje:=FALSE;
    end;
    if not ((zasobnik[0]<>nil) and f^.podle_disc) then goto ne;
    dpoleFill(nil,dpole,false); // inicializace na 0
    // jeste podle disciplin
    for i:=0 to zn-1 do // informace o disciplinach
      dpoleFill(zasobnik[i],dpole,true);

    vyhovuje2:=TRUE;
    for j:=1 to 4 do begin
      if f^.DisList[j]=nil then continue;
      if f^.DisList[j].Count=0 then continue;
      for k:=0 to f^.DisList[j].Count-1 do begin
        di:=f^.DisList[j].Items[k];
        if di=nil then continue;
        case j of
          1: begin n:=3; o:=3;end;
          2: begin n:=3; o:=1;end;
          3: begin n:=1; o:=1;end;
          4: begin n:=1; o:=0;end;
          else begin
            n:=0;o:=1;
          end;
        end;
        vyhovuje2:=dTest(di, n, o, dpole);
        if not vyhovuje2 then break;
      end;
      if not vyhovuje2 then break;
    end;
    if vyhovuje2 then goto tridy_ok;
    goto ne;
  end else if f^.podle_disc then begin
    goto ne;
  end else goto tridy_ok; // ANI PODLE TRID, ANI PODLE DIS., takze podle STATS - DODELAT

  tridy_ok: // sem se skocilo kdyz se nasla vyhovujici podminka
  if DelList<>nil then begin
    for i:=0 to DelList.Count-1 do begin
      rs:=z^.rocni_slozky.Extract(DelList.Items[i]);
      rs^.vysledky.Free;
      rs^.vysledky:=nil;
      Dispose(rs);
      DelList.Items[i]:=nil;
    end;
    DelList.Clear;
    DelList.Free;
  end;
  if ZrusRS then begin
    z^.rocni_slozky.Free;
    z^.rocni_slozky:=nil;
  end;
  VyhovujeFiltru:=TRUE;
  exit;
  ne:
  if DelList<>nil then begin
    for i:=0 to DelList.Count-1 do begin
      rs:=z^.rocni_slozky.Extract(DelList.Items[i]);
      rs^.vysledky.Free;
      rs^.vysledky:=nil;
      Dispose(rs);
      DelList.Items[i]:=nil;
    end;
    DelList.Clear;
    DelList.Free;
  end;
  if ZrusRS then begin
    z^.rocni_slozky.Free;
    z^.rocni_slozky:=nil;
  end;
  VyhovujeFiltru:=FALSE;
end;

function fCreateItem:PFiltrItem;
var item:PFiltrItem;
begin
  New(item);
  item^.Roky :=TList.Create;
  item^.Tridy:=TList.Create;
  fCreateItem:=item;
end;

function fAddItem(f:PFiltr;i:PFiltrItem):PFiltrItem;
begin
  if f = nil then begin
    fAddItem:=nil;
    exit;
  end;
  if i = nil then i:=fCreateItem
  else begin
    if i^.Roky=nil then i^.Roky:=TList.Create;
    if i^.Tridy=nil then i^.Tridy:=TList.Create;
  end;
  if f^.ItemList=nil then f^.ItemList:=TList.Create;
  f^.ItemList.Add(i);
  fAddItem:=i;
end;

procedure DealokujFiltr(var f:PFiltr);
var i,j:integer;
    fi:PFiltrItem;
    ri:PRokyItem;
    ti:PTridyItem;
begin
  if f=nil then exit;
  if f^.ItemList <> nil then begin
    for i:=0 to f^.ItemList.Count-1 do begin
      fi:=f^.ItemList.Items[i];
      if fi <> nil then begin
        if fi^.Roky <> nil then begin
          for j:=0 to fi^.Roky.Count-1 do begin
            ri:=fi^.Roky.Items[j];
            Dispose(ri);
          end;
          fi^.Roky.Free; fi^.Roky:=nil;
        end;
        if fi^.Tridy <> nil then begin
          for j:=0 to fi^.Tridy.Count-1 do begin
            ti:=fi^.Tridy.Items[j];
            Dispose(ti);
          end;
          fi^.Tridy.Free; fi^.Tridy:=nil;
        end;
      end;
      Dispose(fi);
    end;
    f^.ItemList.Free; f^.ItemList:=nil;
  end;
  for j:=1 to 4 do begin
    if f^.DisList[j] <> nil then begin
      with f^.DisList[j] do begin
        for i:=0 to Count-1 do
          Dispose(Items[i]);
        Free;
      end;
      f^.DisList[j]:=nil
    end;
  end;
  Dispose(f); f:=nil;
end;

//sd - discipliny
function VytvorFiltr(s,sd:string):PFiltr;
var i,id:integer;
    item:string;
procedure Scan(var s:string); // - nacitaci procedura, nacte vzdy jeden
var a,b:integer;              //   objekt, ten ulozi do retezce a do id jeho typ
begin
  item:='';
  id:=-1;
  if i > length(s) then exit;
  repeat
    case s[i] of
      '0'..'9':begin
        if (id<0)or(id=0) then begin
          id:=0;item:=item+s[i];
        end else break;
      end;
      'I','V':begin
        if (id<0)or(id=1) then begin
          id:=1;item:=item+s[i];
        end else break;
      end;
      'A'..'H','J'..'U','W'..'Z':begin
        if (id<0)or(id=5) then begin
          id:=5;item:=item+s[i];
        end else break;
      end;
      '-':begin
        if (id<0)or(id=2) then begin
          id:=2;item:=item+s[i];
        end else break;
      end;
      ',',' ':begin
        if (id<0)or(id=3) then begin
          id:=3;item:=item+s[i];
        end else break;
      end;
      '.':begin
        if (id<0)or(id=4) then begin
          id:=4;item:=item+s[i-1];
        end else break;
      end;
    else
      id:=-2; // spatny format retezce filtru
      exit;
    end;
    inc(i);
  until i > length(s);
  if id=1 then begin
    a:=RimskeNaRocnik(item);
    str(a,item);
  end else if id in [2..3] then item:=item[1]
  else if (id=4)and(length(item)>1) then id:=2
  else if id=0 then begin
    val(item,a,b);
    if a > 8 then id :=6 // rok
  end;
end;
//id        0       1       2        3       4      5     6
//vznam tda4G trida8G rozmez separtor teka psmena rok
var f:PFiltr;
    fi:PFiltrItem;
    ri:PRokyItem;
    ti:PTridyItem;
    a,b,c,d:integer;
    di:PDistItem;
begin
  New(f);
  f^.podle_trid:=FALSE;
  f^.podle_disc:=FALSE;
  f^.ItemList:=TList.create;
  for i:=1 to 4 do
    f^.DisList[i]:=TList.create;
  i:=1;
  Scan(s); // melo by nacist rok
  repeat
    if id = 6 then begin
      val(item,a,b);
      New(ri);
      ri.rok1:=a;
      ri.rok2:=a;
      fi:=fCreateItem;
      fi^.Roky.Add(ri);
      fAddItem(f,fi);
      repeat    // nacita seznam roku, pokud nejaky existuje
        c:=id;  // predchozi objekt
        Scan(s);// nacte novy
        if id=4 then id:=3; // tecku prevede na separator
        if (id=3)and(c=2) then id:=2;
        if id = 6 then begin           // jedna se o rok
          val(item,a,b);
          if c = 3 then begin          // minule separator
            New(ri);
            ri^.rok1:=a;
            ri^.rok2:=a;
            fi^.Roky.Add(ri);
          end else if c = 2 then begin // minule rozmezi
            ri^.rok2:=a;
          end;
        end else if id < 0 then break;
      until(id<>6)and(id<>2)and(id<>3);
      if id < 0 then break;
      if not(id in [0,1]) then begin
        id:=-2;
        break;
      end;
      val(item,a,b);
      New(ti);
      if id=0 then ti^.typ_studia:=4
      else         ti^.typ_studia:=8;
      ti^.trida1:=a;
      ti^.trida2:=a;
      ti^.pismeno:=' ';
      fi^.Tridy.Add(ti);
      repeat    // nacita seznam trid, pokud nejaky existuje
        c:=id;  // predchozi objekt
        Scan(s);// nacte novy
        if id = 4 then id:=3; // tecku prevede na separator
        if (id=3)and(c=2) then id:=2;
        if id in [0,1] then begin      // jedna se o tridu
          val(item,a,b);
          if c = 3 then begin          // minule separator
            New(ti);
            if id=0 then ti^.typ_studia:=4
            else         ti^.typ_studia:=8;
            ti^.trida1:=a;
            ti^.trida2:=a;
            ti^.pismeno:=' ';
            fi^.Tridy.Add(ti);
          end else if c = 2 then begin // minule rozmezi
            ti^.trida2:=a;
          end;
        end else if id = 6 then break
        else if id = 5 then begin // pismeno
          ti^.pismeno:=item[1];
        end;
      until id<0;
    end else if id <> -1 then id:=-2;
  until id < 0;
  if id <> -1 then begin
    DealokujFiltr(f);
    f:=nil;VytvorFiltr:=f;
    exit;
  end;
  if f^.ItemList.Count>0 then f^.podle_trid:=TRUE;

  // id         0         2       3                5
  // vyznam disciplina rozmezi separator (stav RadioButton A-D)
  i:=1;
  Scan(sd);
  repeat
    if (id=1)or(id=6) then id:=0;
    if id=4 then id:=3;
    if id=5 then begin
      if not (item[1] in ['A'..'D']) then begin
        id:=-3;
        break;
      end;
      d:=Ord(item[1])-Ord('A')+1;
      di:=nil;
      repeat
        c:=id;
        Scan(sd);
        if id in [1,6] then id:=0 else
        if id = 4 then id:=3; // tecku prevede na separator
        if (id=3)and(c=2) then id:=2;
        if id = 0 then begin
          val(item,a,b);
          if c = 3 then begin
            New(di);
            di^.d1:=a;
            di^.d2:=a;
            f^.DisList[d].Add(di);
          end else if c = 2 then begin
            if di<>nil then di^.d2:=a;
          end;
        end else if id = 5 then break;
      until id < 0;
    end else if id <> -1 then id:=-3;
  until id < 0;
  if id <> -1 then begin
    DealokujFiltr(f);
    f:=nil;VytvorFiltr:=f;
    exit;
  end;
  for i:=1 to 4 do
    if f^.DisList[i]<>nil then if f^.DisList[i].Count>0 then begin
      f^.podle_disc:=TRUE;
      break;
    end;
  VytvorFiltr:=f;
end;

procedure FiltrToString(f:PFiltr;var s:string);
var i,j:integer;
    fi:PFiltrItem;
    ri:PRokyItem;
    ti:PTridyItem;
    di:PDistItem;
    sp1,sp2:string;
begin
  s:='';
  if f=nil then exit;
  if f^.ItemList <> nil then begin
    for i:=0 to f^.ItemList.Count-1 do begin
      fi:=f^.ItemList.Items[i];
      if fi <> nil then begin
        if fi^.Roky <> nil then begin
          for j:=0 to fi^.Roky.Count-1 do begin
            ri:=fi^.Roky.Items[j];
            str(ri^.rok1,sp1);
            str(ri^.rok2,sp2);
            s:=s+sp1;
            if ri^.rok1<>ri^.rok2 then
              s:=s+'-'+sp2;
            s:=s+', ';
          end;
        end;
        if fi^.Tridy <> nil then begin
          for j:=0 to fi^.Tridy.Count-1 do begin
            ti:=fi^.Tridy.Items[j];
            if ti^.typ_studia = 8 then begin
              RocnikNaRimske(ti^.trida1,sp1);
              RocnikNaRimske(ti^.trida2,sp2);
            end else begin
              str(ti^.trida1,sp1);
              str(ti^.trida2,sp2);
            end;
            sp1:=sp1+ti^.pismeno;
            sp2:=sp2+ti^.pismeno;
            s:=s+sp1;
            if ti^.trida1<>ti^.trida2 then
              s:=s+'-'+sp2;
            s:=s+', ';
          end;
        end;
      end;
    end;
  end;
  s:=s+'|D:|';
  for j:=1 to 4 do begin
    if f^.DisList[j] <> nil then begin
      s:=s+Chr(Ord('A')+j-1)+', ';
      with f^.DisList[j] do begin
        for i:=0 to Count-1 do begin
          di:=Items[i];
          str(di^.d1, sp1);
          str(di^.d2, sp2);
          s:=s+sp1;
          if di^.d1<>di^.d2 then
            s:=s+'-'+sp2;
          s:=s+', ';
        end;
      end;
    end;
  end;
end;

procedure DealokujSchema(s:PSchema);
var i:integer;
    p:^integer;
begin
  if s<>nil then begin
    if s^.discipliny<>nil then begin
      for i:=0 to s^.discipliny.Count-1 do begin
        p:=s^.discipliny.Items[i];
        s^.discipliny.Items[i]:=nil;
        Dispose(p);
      end;
      s^.discipliny.Free;
      s^.discipliny:=nil;
    end;
    Dispose(s);
  end;
end;

function CompareStrings(const s1, s2:string):integer;
var m1,m2,m,i:integer;
    c1,c2:byte;
    cd1,cd2:byte;
begin
  cd1:=0;
  cd2:=0;
  m1:=length(s1);m2:=length(s2);
  if m1>=m2 then m:=m2 else m:=m1;
  for i:=1 to m do begin
    c1:=Ord(s1[i]);c2:=Ord(s2[i]);
    if c1=c2 then continue;
    if poradi_znaku_bez_D[c1]=poradi_znaku_bez_D[c2] then begin
      if cd1=0 then begin
        cd1:=c1;
        cd2:=c2;
        if poradi_znaku[cd1]>poradi_znaku[cd2] then CompareStrings:=2
        else CompareStrings:=-2;
        exit;
      end;
      continue;
    end;
    if poradi_znaku_bez_D[c1] > poradi_znaku_bez_D[c2] then begin
      CompareStrings:=1;exit;
    end else if poradi_znaku_bez_D[c1] < poradi_znaku_bez_D[c2] then begin
      CompareStrings:=-1;exit;
    end else begin
      if c1>c2 then begin
        CompareStrings:=1;exit;
      end else if c1<c2 then begin
        CompareStrings:=-1;exit;
      end;
    end;
  end;
  if m1>m2 then CompareStrings:=2
  else if m1<m2 then CompareStrings:=-2
  else begin
    if cd1<>0 then begin
      if poradi_znaku[cd1]>poradi_znaku[cd2] then CompareStrings:=2
      else CompareStrings:=-2;
      exit;
    end;
    CompareStrings:=0;
  end;
end;

function cmp0(i1,i2:integer):integer;
begin
  if i1>i2 then cmp0:=1
  else if i1<i2 then cmp0:=-1
  else cmp0:=0;
end;

// studuje
function cmp1(var pz1,pz2:PZak):integer;
begin
  cmp1:=-cmp0(integer(pz1^.studuje),integer(pz2^.studuje));
end;

// typ studia
function cmp2(var pz1,pz2:PZak):integer;
begin
  cmp2:=-cmp0(pz1^.typ_studia,pz2^.typ_studia);
end;

// rocnik
function cmp3(var pz1,pz2:PZak):integer;
var i1,i2:integer;
begin
  with pz1^ do begin
    if studuje then i1:=aktualni_trida
    else i1:=posledni_trida;
    if typ_studia=4 then inc(i1,4);
  end;
  with pz2^ do begin
    if studuje then i2:=aktualni_trida
    else i2:=posledni_trida;
    if typ_studia=4 then inc(i2,4);
  end;
  cmp3:=cmp0(i1,i2);
end;

// pismeno tridy
function cmp4(var pz1,pz2:PZak):integer;
begin
  cmp4:=cmp0(Ord(pz1^.pismeno_tridy),Ord(pz2^.pismeno_tridy));
end;

// prijmeni a jmeno
function cmp5(var pz1,pz2:PZak):integer;
var s1,s2,s3:string;
    i:integer;
begin
  s3:=pz1^.jmeno;s1:=pz1^.prijmeni+' '+s3;
  s3:=pz2^.jmeno;s2:=pz2^.prijmeni+' '+s3;
  i:=CompareStrings(s1,s2);
  if i=-2 then i:=-1
  else if i=2 then i:=1;
  cmp5:=i;
end;

// pohlavi (1. muz, 2. zena)
function cmp6(var pz1,pz2:PZak):integer;
begin
  cmp6:=-cmp0(integer(pz1^.muz),integer(pz2^.muz));
end;

// vysledky *9*
function cmp7(var pz1,pz2:PZak):integer;
var s:string;
    i,j,d,t:integer;
    b1,b2:boolean; // b1 - roziseni jednotek, b2 - obdobi studia
    v1,v2,v1min,v2min:real;
    rs:PRocniSlozka;
    pv:PVysledek;
    pd:PDisciplina;
begin
  with MainWindow do begin
    with ComboBox2 do begin
      if ItemIndex<0 then begin
        cmp7:=0;exit;
      end;
      s:=Items.Values[Items.Names[ItemIndex]];
      val(s,d,j);
      if j<>0 then begin
        cmp7:=0;exit;
      end;
    end;
    if RadioGroup8.ItemIndex=0 then b1:=TRUE else b1:=FALSE;
    if RadioGroup9.ItemIndex=0 then b2:=TRUE else b2:=FALSE;
  end;
  v1:=-1;v2:=-1;
  v1min:=-1;v2min:=-1;
  with pz1^ do begin
    if studuje then t:=aktualni_trida
    else t:=posledni_trida;
    if rocni_slozky<>nil then begin
      if b2 then begin
        for i:=0 to rocni_slozky.Count-1 do begin
          rs:=rocni_slozky.Items[i];
          if rs=nil then continue;
          if rs^.vysledky=nil then continue;
          with rs^.vysledky do begin
            for j:=0 to Count-1 do begin
              pv:=Items[j];
              if pv^.Disciplina<>d then continue;
              if pv^.jednotek>v1 then v1:=pv^.jednotek;
              if(pv^.jednotek<v1min)or(v1min=-1) then v1min:=pv^.jednotek;
            end;
          end;
        end;
      end else begin
        for i:=0 to rocni_slozky.Count-1 do begin
          rs:=rocni_slozky.Items[i];
          if rs=nil then continue;
          if (rs^.vysledky=nil)or(rs^.trida<>t) then continue;
          with rs^.vysledky do begin
            for j:=0 to Count-1 do begin
              pv:=Items[j];
              if pv=nil then continue;
              if pv^.Disciplina<>d then continue;
              if pv^.jednotek>v1 then v1:=pv^.jednotek;
              if(pv^.jednotek<v1min)or(v1min=-1) then v1min:=pv^.jednotek;
            end;
          end;
        end;
      end;
    end;
  end;
  with pz2^ do begin
    if studuje then t:=aktualni_trida
    else t:=posledni_trida;
    if rocni_slozky<>nil then begin
      if b2 then begin
        for i:=0 to rocni_slozky.Count-1 do begin
          rs:=rocni_slozky.Items[i];
          if rs=nil then continue;
          if rs^.vysledky=nil then continue;
          with rs^.vysledky do begin
            for j:=0 to Count-1 do begin
              pv:=Items[j];
              if pv^.Disciplina<>d then continue;
              if pv^.jednotek>v2 then v2:=pv^.jednotek;
              if(pv^.jednotek<v2min)or(v2min=-1) then v2min:=pv^.jednotek;
            end;
          end;
        end;
      end else begin
        for i:=0 to rocni_slozky.Count-1 do begin
          rs:=rocni_slozky.Items[i];
          if rs=nil then continue;
          if (rs^.vysledky=nil)or(rs^.trida<>t) then continue;
          with rs^.vysledky do begin
            for j:=0 to Count-1 do begin
              pv:=Items[j];
              if pv=nil then continue;
              if pv^.Disciplina<>d then continue;
              if pv^.jednotek>v2 then v2:=pv^.jednotek;
              if(pv^.jednotek<v2min)or(v2min=-1) then v2min:=pv^.jednotek;
            end;
          end;
        end;
      end;
    end;
  end;
  // v1 - vysledek zaka 1, v2 - vysledek zaka 2
  // v?=0 znamena, ze nedelal disciplinu
  // v?=-1 znamena, ze disciplinu nema ani ve slozce
  if not b1 then begin // rozlisuji se jednotky
    i:=0;
    if MDL<>nil then
      for j:=0 to MDL.Count-1 do begin
        pd:=MDL.Items[j];
        if pd=nil then continue;
        if pd^.id=d then begin
          if pd^.format_jednotky=2 then i:=-1; // zamena casoveho udaje
          break;
        end;
      end;
    if i=-1 then begin // provnavame minima - cim mensi, tim lepsi
      if (v1min<=0)or(v2min<=0)or(v1min=v2min)then begin
        if v1min=v2min then i:=0 else
        if v1min<v2min then i:=1 else i:=-1;
      end else
        if v1min>v2min then i:=1 else i:=-1;
    end else begin // porovnavame maxima - cim vetsi, tim lepsi
      if (v1<=0)or(v2<=0)or(v1=v2)then begin
        if v1=v2 then i:=0 else
        if v1<v2 then i:=1 else i:=-1;
      end else
        if v1>v2 then i:=-1 else i:=1;
    end;


  end else begin
    if v1>v2 then i:=1
    else if v1<v2 then i:=-1
    else i:=0;
  end;
  cmp7:=i;
end;

// datum narozeni
function cmp8(var pz1,pz2:PZak):integer;
var i:integer;
begin
  i:=cmp0(pz1^.datum_narozeni.r,pz2^.datum_narozeni.r);
  if i=0 then begin
    i:=cmp0(pz1^.datum_narozeni.m,pz2^.datum_narozeni.m);
    if i=0 then
      i:=cmp0(pz1^.datum_narozeni.d,pz2^.datum_narozeni.d);
  end;
  cmp8:=i;
end;

// datum zacatku studia
function cmp9(var pz1,pz2:PZak):integer;
var i:integer;
begin
  i:=cmp0(pz1^.zacatek_studia.r,pz2^.zacatek_studia.r);
  if i=0 then begin
    i:=cmp0(pz1^.zacatek_studia.m,pz2^.zacatek_studia.m);
    if i=0 then
      i:=cmp0(pz1^.zacatek_studia.d,pz2^.zacatek_studia.d);
  end;
  cmp9:=i;
end;

function CompareFunction(pz1, pz2:PZak):integer;
var i:integer;
    p:^integer;
    res:integer;
begin
  res:=0;
  if (pz1=nil) and (pz2=nil) then begin
    CompareFunction:=0;exit;
  end;
  if (pz1=nil) then begin
    CompareFunction:=-1;exit;
  end else if pz2=nil then begin
    CompareFunction:=1;exit;
  end;
  with MainWindow do begin
    with ListView5.Items do begin
      for i:=0 to Count-1 do begin
        if Item[i]=nil then continue;
        if Item[i].Data=nil then continue;
        p:=Item[i].Data;
        if p=nil then continue;
        if not (p^ in [1..9]) then continue;
        case p^ of
          1: res:=cmp1(pz1,pz2);
          2: res:=cmp2(pz1,pz2);
          3: res:=cmp3(pz1,pz2);
          4: res:=cmp4(pz1,pz2);
          5: res:=cmp5(pz1,pz2);
          6: res:=cmp6(pz1,pz2);
          7: res:=cmp7(pz1,pz2);
          8: res:=cmp8(pz1,pz2);
          9: res:=cmp9(pz1,pz2);
        end;
        with Item[i] do
          if Length(Caption)>1 then
            if Caption[length(Caption)-1]='-' then res:=-res;
        if res<>0 then break;
      end;
    end;
  end;
  CompareFunction:=res;
end;

function StrConv(src:string):PChar;
var x,i:integer;
    p:PChar;
begin
  x:=length(src);
  p:=StrAlloc(x+1);
  if p=nil then begin
    StrConv:=nil;
    exit;
  end;
  for i:=1 to x do
    p[i-1]:=src[i];
  p[x]:=#0;
  StrConv:=p;
end;

function  VyhovujeHledani(pz:PZak):Boolean;
var s1,s2:string;
    i,j:integer;
label ano, ne;
begin
  if pz=nil then goto ne;
  with MainWindow do begin
    s1:=Edit14.Text;
    if s1<>'' then begin
      if pz^.prijmeni<>nil then s2:=pz^.prijmeni
      else goto ne;
      j:=CompareStrings(s1,s2);
      if (j=-1)or(j>0) then goto ne;
    end;
    s1:=Edit17.Text;
    if s1<>'' then begin
      if pz^.jmeno<>nil then s2:=pz^.jmeno
      else goto ne;
      j:=CompareStrings(s1,s2);
      if (j=-1)or(j>0) then goto ne;
    end;
    s1:=Edit18.Text;
    if s1<>'' then begin
      if pz^.bydliste<>nil then s2:=pz^.bydliste
      else goto ne;
      j:=CompareStrings(s1,s2);
      if (j=-1)or(j>0) then goto ne;
    end;
    s1:=Edit19.Text;
    if s1<>'' then begin
      val(s1,i,j);if j<>0 then goto ne;
      if i<>pz^.cislo_domu then goto ne;
    end;
    s1:=Edit20.Text;
    if s1<>'' then begin
      val(s1,i,j);if j<>0 then goto ne;
      if i<>pz^.datum_narozeni.r then goto ne;
    end;
  end;
  ano:
  VyhovujeHledani:=TRUE;
  exit;
  ne:
  VyhovujeHledani:=FALSE;
end;

end.
