unit RocniSlozky;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TSlozky = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListView2: TListView;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    GroupBox3: TGroupBox;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Button13: TButton;
    Button14: TButton;
    Edit5: TEdit;
    Edit6: TEdit;
    Button15: TButton;
    Button16: TButton;
    Edit7: TEdit;
    Edit8: TEdit;
    ComboBox1: TComboBox;
    procedure ListView2Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure ListView1Compare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure Button8Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure ComboBox1Enter(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit7Exit(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
    procedure Edit8Exit(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
    procedure Dealokuj(t:Tlist);
    procedure UpdateViews;
    procedure UpdateView2;
    { Private declarations }
  public
    procedure NastavPredlohu(t:TList);
    { Public declarations }
  end;

var
  Slozky        :TSlozky;
  SlozkyTransfer:TList;

implementation

uses MyTypes, MyUtils, Data, Main, My_IO;
var trs:TList;

{$R *.DFM}

procedure TSlozky.Dealokuj(t:TList);
var i,j:integer;
    prs:PRocniSlozka;
    pv:PVysledek;
begin
  if t<>nil then begin
    for i:=0 to t.Count-1 do begin
      prs:=t.Items[i];
      if prs <> nil then begin
        if prs^.vysledky<>nil then begin
          for j:=0 to prs^.vysledky.Count-1 do begin
            pv:=prs^.vysledky.Items[j];
            Dispose(pv);
          end;
          prs^.vysledky.Free;
        end;
        Dispose(prs);
      end;
    end;
    t.Free;
  end;
end;

procedure TSlozky.NastavPredlohu(t:TList);
begin
  if trs<>nil then
    Dealokuj(trs);
  trs:=nil;
  CreateRS(t,trs);
end;

procedure TSlozky.FormCreate(Sender: TObject);
begin
  SlozkyTransfer:=nil;
  trs:=nil;
  ClearLV(ListView1);
  ClearLV(ListView2);
end;

procedure TSlozky.FormActivate(Sender: TObject);
begin
  if trs=nil then CreateRS(nil, trs);
  ClearLV(ListView1);
  ClearLV(ListView2);
  UpdateViews;
  RefreshDisCB(MDL,ComboBox1,FALSE);
end;

procedure TSlozky.UpdateView2;
var prs:PRocniSLozka;
    pvl:TList;
    pv:PVysledek;
    i,id:integer;
    j:Real;
    ListItem:TListItem;
    s:string;
    p:pointer;
begin
  GroupBox2.Caption:='';
  if ListView2.SelCount=1 then p:=ListView2.Selected
  else p:=nil;
  ClearLV(ListView2);
  if ListView1.SelCount<>1 then exit;
  if ListView1.Selected=nil then exit;
  GroupBox2.Caption:='[ '+ListView1.Selected.Caption+' ('+ListView1.Selected.SubItems.Strings[0]+') ]';
  prs:=ListView1.Selected.Data;
  pvl:=prs^.vysledky;
  for i:=0 to pvl.Count-1 do begin
    pv:=pvl.Items[i];
    str(pv^.Disciplina, s);
    ListItem:=ListView2.Items.Add;
    ListItem.Data:=pv;
    ListItem.Caption:=s;
    if (pv=p)and(ListView2.SelCount=0) then ListItem.Selected:=TRUE;
    GetDisciplineName(pv^.Disciplina,s);
    ListItem.SubItems.Add(s);
    j:=pv^.jednotek;
    str(j:0:2,s);
    ListItem.SubItems.Add(s);
    id:=pv^.Disciplina;
    str(id,s);
    J2F(j, s);
    ListItem.SubItems.Add(s);
  end;
end;

procedure TSlozky.UpdateViews;
var i:integer;
    t1,t2:TSortType;
    prs:PRocniSlozka;
    trida:integer;
    datum:TDatum;
    ListItem:TListItem;
    s,s2:string;
    rs1:PRocniSlozka;
begin
  ClearLV(ListView1);
  ClearLV(ListView2);
  if trs=nil then exit;
  t1:=ListView1.SortType;
  t2:=ListView2.SortType;
  ListView1.SortType:=stNone;
  ListView2.SortType:=stNone;
  if ListView1.SelCount=1 then rs1:=ListView1.Selected.Data
  else rs1:=nil;
  // naplni ListView1
  for i:=0 to trs.Count-1 do begin
    prs:=trs.Items[i];
    if prs<>nil then begin
      trida :=prs^.trida;
      datum :=prs^.pocatek;
      ListItem:=ListView1.Items.Add;
      Str(trida,s);
      ListItem.caption:=s;
      ListItem.data:=prs;
      if (prs=rs1)and(ListView1.SelCount=0) then begin
        ListItem.Selected:=TRUE;
        ListView1.Selected:=ListItem;
      end;
      Str(datum.d,s);
      Str(datum.m,s2);
      s:=s+'. '+s2+'. ';
      Str(datum.r,s2);
      s:=s+s2;
      ListItem.SubItems.add(s);
    end;
  end;
  // naplni ListView2
  UpdateView2;
  ListView1.SortType:=t1;
  ListView2.SortType:=t2;
end;

procedure TSlozky.ListView2Compare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var i1,i2,i:integer;
begin
  val(Item1.Caption,i1,i);
  val(Item2.Caption,i2,i);
  if i1>i2 then Compare:=1
  else if i1<i2 then Compare:=-1
  else Compare:=0;
end;

procedure TSlozky.Button2Click(Sender: TObject);
begin
  if (ListView1.SelCount=1)and(ListView1.Selected<>nil)then begin
    Edit1.Text:=ListView1.Selected.Caption;
  end;
  Edit1.SetFocus;
  Button13.Enabled:=TRUE;
  Button14.Enabled:=TRUE;
  Button13.Tag:=2;
end;

procedure TSlozky.Button1Click(Sender: TObject);
begin
  Edit1.SetFocus;
  Button13.Enabled:=TRUE;
  Button14.Enabled:=TRUE;
  Button13.Tag:=1;
end;

procedure TSlozky.Button14Click(Sender: TObject);
begin
  Edit1.Text:='';Edit2.Text:='';
  Edit3.Text:='';Edit4.Text:='';
  Button13.Enabled:=FALSE;
  Button14.Enabled:=FALSE;
  Button13.Tag:=0;
end;

procedure TSlozky.Button13Click(Sender: TObject);
var a,b,c,d,x,i,j:integer;
    ListItem:TListItem;
    s1,s2:string;
    prs:PRocniSlozka;
    label konec;
begin
  val(Edit1.text,a,x); if x<>0 then goto konec;
  val(Edit2.text,b,x); if x<>0 then goto konec;
  val(Edit3.text,c,x); if x<>0 then goto konec;
  val(Edit4.text,d,x); if x<>0 then goto konec;
    s1:=Edit1.Text;
    s2:=Edit2.Text+'. '+Edit3.Text+'. '+Edit4.Text;
    j:=-1;
    for i:=0 to trs.Count-1 do begin
      prs:=trs.Items[i];
      if (prs^.trida=a)and(prs^.pocatek.d=b)and(prs^.pocatek.m=c)
                       and(prs^.pocatek.r=d)then begin
        j:=i;
        break;
      end;
    end;

    if Button13.Tag=1 then begin // vkladani
      if j>=0 then
        MyMessageBox('Sloka ji existuje.', 'Info', MB_OK)
      else begin
        new(prs);
        prs^.trida:=a;
        prs^.pocatek.d:=b;
        prs^.pocatek.m:=c;
        prs^.pocatek.r:=d;
        prs^.vysledky:=TList.Create;
        trs.Add(prs);
        ListItem:=ListView1.Items.Add;
        ListItem.Data:=prs;
        ListItem.Caption:=s1;
        ListItem.SubItems.Add(s2);
        ListItem.Selected:=TRUE;
        ClearLV(ListView2);
      end;
    end else if Button13.Tag=2 then begin // editace
      if ListView1.SelCount=1 then begin
        prs:=ListView1.Selected.Data;
        if j>=0 then begin
          if (prs^.trida<>a)or(prs^.pocatek.d<>b)or(prs^.pocatek.m<>c)
                            or(prs^.pocatek.r<>d)then begin
            MyMessageBox('Sloka ji existuje.', 'Info', MB_OK);
          end;
        end else begin
          ListView1.Selected.Caption:=s1;
          ListView1.Selected.SubItems.Strings[0]:=s2;
          GroupBox2.Caption:='[ '+s1+' ('+s2+') ]';
          prs^.trida:=a;
          prs^.pocatek.d:=b;
          prs^.pocatek.m:=c;
          prs^.pocatek.r:=d;
        end;
      end else begin
        if j<0 then
          MyMessageBox('Sloka nenalezena.', 'Info', MB_OK)
        else begin
          ListView1.Items.Item[j].Selected:=TRUE;
          Edit1.SetFocus;
          exit;
        end;
      end;
    end;
  konec:
  Edit1.Text:='';Edit2.Text:='';
  Edit3.Text:='';Edit4.Text:='';
  Button13.Enabled:=FALSE;
  Button14.Enabled:=FALSE;
  if Button13.Tag=1 then Button1.SetFocus
  else if Button13.Tag=2 then Button2.SetFocus;
  Button13.Tag:=0;
  //UpdateViews;
end;

procedure TSlozky.ListView1Compare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var v1,v2,x:integer;
begin
  val(Item1.Caption,v1,x);
  val(Item2.Caption,v2,x);
  if v1>v2 then
    compare:=1
  else if v1<v2 then
    compare:=-1
  else
    compare:=0;
end;

procedure TSlozky.Button3Click(Sender: TObject);
var i:integer;
    prs:PRocniSlozka;
    pv:PVysledek;
begin
  if ListView1.SelCount=1 then begin
    i:=MyMessageBox('Opravdu smazat?', 'Info', MB_YESNO);
    if i<>IDYES then exit;
    i:=ListView1.Selected.Index;
    prs:=ListView1.Selected.Data;
    ListView1.Selected.Data:=nil;
    ListView1.Selected.SubItems.Clear;
    ListView1.Selected.Delete;
    if (i=ListView1.Items.Count)and(i>0) then dec(i);
    if i<ListView1.Items.Count then ListView1.Items.Item[i].Selected:=TRUE;

    if prs^.vysledky<>nil then begin
      for i:=0 to prs^.vysledky.Count-1 do begin
        pv:=prs^.vysledky.Items[i];
        Dispose(pv);
      end;
      prs^.vysledky.Free;
    end;
    i:=trs.IndexOf(prs);
    Dispose(prs);
    trs.Delete(i);
    Button3.SetFocus;
  end;
end;

procedure TSlozky.Button9Click(Sender: TObject);
begin
  SlozkyTransfer:=trs;
  trs:=nil;
  Close;
end;

procedure TSlozky.Button10Click(Sender: TObject);
begin
  Dealokuj(trs);trs:=nil;
  SlozkyTransfer:=nil;
  Close;
end;

procedure TSlozky.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  trs:=nil;
end;

procedure TSlozky.Button4Click(Sender: TObject);
begin
  ComboBox1.SetFocus;
  Button15.Enabled:=TRUE;
  Button16.Enabled:=TRUE;
  Button15.Tag:=1;
end;

procedure TSlozky.Button5Click(Sender: TObject);
var pv:PVysledek;
begin
  if (ListView2.SelCount=1)and(ListView2.Selected<>nil)then begin
    pv:=ListView2.Selected.Data;
    if pv<>nil then begin
      Edit5.Text:=ListView2.Selected.Caption;
      Edit6.Text:=ListView2.Selected.SubItems.Strings[0];
      Edit7.Text:=ListView2.Selected.SubItems.Strings[1];
      Edit8.Text:=ListView2.Selected.SubItems.Strings[2];
    end;
  end;
  ComboBox1.SetFocus;
  Button15.Enabled:=TRUE;
  Button16.Enabled:=TRUE;
  Button15.Tag:=2;
end;

procedure TSlozky.Button6Click(Sender: TObject);
var prs:PRocniSlozka;
    pv:PVysledek;
    pvl:TList;
    i:integer;
begin
  if ListView1.SelCount<>1 then exit;
  if ListView2.SelCount<>1 then exit;
  pv:=ListView2.Selected.Data;
  prs:=ListView1.Selected.Data;
  if (pv=nil)or(prs=nil) then exit;
  pvl:=prs^.vysledky;
  if pvl=nil then exit;
  i:=MyMessageBox('Opravdu smazat tuto poloku?','Dotaz',MB_YESNO);
  if i<>IDYES then exit;
  i:=pvl.IndexOf(pv);
  if i<0 then exit;
  Dispose(pv);
  pvl.Items[i]:=nil;
  pvl.Delete(i);
  i:=ListView2.Selected.Index;
  ListView2.Selected.SubItems.Clear;
  ListView2.Selected.Data:=nil;
  ListView2.Selected.Delete;
  if (i=ListView2.Items.Count)and(i>0) then dec(i);
  if (i<ListView2.Items.Count)then ListView2.Items.Item[i].Selected:=TRUE;
  Button6.SetFocus;
end;

procedure TSlozky.Button15Click(Sender: TObject);
var id, x, i, j:integer;
    jednotek:Real;
    pv:PVysledek;
    prs:PRocniSlozka;
    pvl:TList;
    ListItem:TListItem;
label konec;
begin
  if ListView1.SelCount<>1 then goto konec;
  if ListView1.Selected=nil then goto konec;
  prs:=ListView1.Selected.Data;
  if prs=nil then goto konec;
  pvl:=prs^.vysledky;
  if pvl=nil then begin
    pvl:=TList.Create;
    prs^.vysledky:=pvl;
  end;
  val(Edit5.Text, id, x); if x<>0 then goto konec;
  val(Edit7.Text, jednotek, x);
  if x<>0 then begin
    jednotek:=0;
    Edit7.Text:='0';
    Edit7.SetFocus;
    Button15.SetFocus;
  end;
  j:=-1;
  for i:=0 to pvl.Count-1 do begin
    pv:=pvl.Items[i];
    if (pv^.Disciplina=id)and(pv.jednotek=jednotek)then begin
      j:=i;
      break;
    end;
  end;

  if Button15.Tag=1 then begin
    if j>=0 then
      MyMessageBox('Sloka ji existuje!','Info',MB_OK)
    else begin
      new(pv);
      pv^.Disciplina:=id;
      pv^.jednotek:=jednotek;
      pvl.Add(pv);
      ListItem:=ListView2.Items.Add;
      ListItem.Data:=pv;
      ListItem.Caption:=Edit5.Text;
      ListItem.SubItems.Add(Edit6.Text);
      ListItem.SubItems.Add(Edit7.Text);
      ListItem.SubItems.Add(Edit8.Text);
    end;
  end else if Button15.Tag=2 then begin
    if ListView2.SelCount=1 then begin
        pv:=ListView2.Selected.Data;
        if j>=0 then begin
          if (pv^.Disciplina<>id)or(pv^.jednotek<>jednotek)then
            MyMessageBox('Sloka ji existuje.', 'Info', MB_OK);
        end else begin
          ListView2.Selected.Caption:=Edit5.Text;
          ListView2.Selected.SubItems.Clear;
          ListView2.Selected.SubItems.Add(Edit6.Text);
          ListView2.Selected.SubItems.Add(Edit7.Text);
          ListView2.Selected.SubItems.Add(Edit8.Text);
          pv^.Disciplina:=id;
          pv^.jednotek:=jednotek;
        end;
      end else begin
        if j<0 then
          MyMessageBox('Sloka nenalezena.', 'Info', MB_OK)
        else begin
          ListView2.Items.Item[j].Selected:=TRUE;
          ComboBox1.SetFocus;
          exit;
        end;
      end;
  end;
  konec:
  Edit5.Text:='';Edit6.Text:='';
  Edit7.Text:='';Edit8.Text:='';
  Button15.Enabled:=FALSE;
  Button16.Enabled:=FALSE;
  if Button15.Tag=1 then Button4.SetFocus
  else if Button15.Tag=2 then Button5.SetFocus;
  Button15.Tag:=0;
end;

procedure TSlozky.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  UpdateView2;
  if Selected=FALSE then GroupBox2.Caption:='';
end;

procedure TSlozky.Button8Click(Sender: TObject);
var i:integer;
    pv:PVysledek;
    pvl:TList;
    prs:PRocniSlozka;
begin
  if (ListView1.SelCount<>1)or(ListView1.Selected=nil) then exit;
  if ListView1.Selected.Data=nil then exit;
  ClearLV(ListView2);
  GroupBox2.Caption:='';
  prs:=ListView1.Selected.Data;
  if prs=nil then exit;
  if prs^.vysledky=nil then exit;
  pvl:=prs^.vysledky;
  for i:=0 to pvl.Count-1 do begin
    pv:=pvl.Items[i];
    Dispose(pv);
    pvl.Items[i]:=nil;
  end;
  pvl.Clear;
end;

procedure TSlozky.Button16Click(Sender: TObject);
begin
  Edit5.Text:='';Edit6.Text:='';
  Edit7.Text:='';Edit8.Text:='';
  Button15.Enabled:=FALSE;
  Button16.Enabled:=FALSE;
  Button15.Tag:=0;
end;

procedure TSlozky.ComboBox1Enter(Sender: TObject);
begin
RefreshDisCB(MDL,ComboBox1,FALSE);
end;

procedure TSlozky.ComboBox1Change(Sender: TObject);
var s:string;
    id:integer;
begin
  if ComboBox1.ItemIndex<0 then exit;
  s:=ComboBox1.Items.Strings[ComboBox1.ItemIndex];
  id:=GetDisciplineID(s);
  Edit6.Text:=s;
  Str(id, s);
  Edit5.Text:=s;
end;

procedure TSlozky.Edit7Exit(Sender: TObject);
var s:string;
    j:real;
    x:integer;
    id:byte;
begin
  s:=Edit7.Text;
  val(s, j, x); if x<>0 then exit;
  s:=Edit5.Text;
  J2F(j, s);
  Edit8.Text:=s;
  val(Edit5.Text, id, x);
  F2J(s, j, id);
  str(j:0:2,s);
  Edit7.Text:=s; 
end;

procedure TSlozky.Edit5Exit(Sender: TObject);
var id,i:integer;
    pd:PDisciplina;
begin
  val(Edit5.Text, id, i); if i<>0 then exit;
  if MDL=nil then exit;
  for i:=0 to MDL.Count-1 do begin
    pd:=MDL.Items[i];
    if id=pd^.id then begin
      Edit6.Text:=pd^.jmeno;
      break;
    end;
  end;
end;

procedure TSlozky.Edit8Exit(Sender: TObject);
var j:Real;
    s:string;
    id, i:integer;
begin
  val(Edit5.Text, id, i); if i<>0 then exit;
  s:=Edit8.Text;
  F2J(s, j, id);
  str(j:0:2, s);
  Edit7.Text:=s;
  s:='';
  str(id, s);
  J2F(j, s);
  Edit8.Text:=s; // normalizovany format ;-)
end;

procedure TSlozky.Button11Click(Sender: TObject);
var rs:PRocniSlozka;
begin
  if (ListView1.Selected=nil)or(ListView1.SelCount<>1) then exit;
  rs:=ListView1.Selected.Data;
  if rs=nil then exit;
  if MS=nil then begin
    MyMessageBox('Nen vytvoeno dn schma.','Info',MB_OK);
    exit;
  end;
  if MS^.discipliny=nil then exit;
  if MS^.discipliny.Count<1 then exit;
  PouzijSchema(MS, rs);
  UpdateView2;
end;

procedure TSlozky.Button12Click(Sender: TObject);
var f:file;
    ps:PSchema;
    rs:PRocniSlozka;
begin
  if (ListView1.Selected=nil)or(ListView1.SelCount<>1) then exit;
  rs:=ListView1.Selected.Data;
  if rs=nil then exit;
  if MainWindow.OpenDialog3.Execute then begin
    try
      AssignFile(f, MainWindow.OpenDialog3.FileName);
      Reset(f,1);
    except
      on EInOutError do begin
        MyMessageBox('Chyba pri otevrn souboru.','Info',MB_OK);
        exit;
      end;
    end;
    try
      NactiSchema(f,ps);
    except
      on EInOutError do
        MyMessageBox('Chyba pi natni dat schmatu.','Info',MB_OK);
    end;
    CloseFile(f);
  end else exit;
  PouzijSchema(ps, rs);
  DealokujSchema(ps);
  UpdateView2;
end;

end.
